#include <stdio.h>
#include <ieee_nan.h>

int main()
{
#if (defined PA-RISK) || (defined MIPS)
    u_int64_t usnan = 0x7FFFFFFFFFFFFFFF;
    u_int64_t uqnan = 0x7FFBFFFFFFFFFFFF;
#else    
    u_int64_t usnan = 0x7FFBFFFFFFFFFFFF;
    u_int64_t uqnan = 0x7FFFFFFFFFFFFFFF;
#endif

    double snan = *(double*)&usnan;
    double qnan = *(double*)&uqnan;

    fprintf(stderr, "snan: %f\n", snan);
    fprintf(stderr, "qnan: %f\n", qnan);

    if (ieee_isnan(snan))
        fprintf(stderr, "snan == nan:  PASS\n");
    else
        fprintf(stderr, "snan != nan:  FAIL\n");
    if (ieee_isSnan(snan))
        fprintf(stderr, "snan == snan:  PASS\n");
    else
        fprintf(stderr, "snan != snan:  FAIL\n");
    if (!ieee_isQnan(snan))
        fprintf(stderr, "snan != qnan:  PASS\n");
    else
        fprintf(stderr, "snan == qnan:  FAIL\n");
    if (ieee_isnan(qnan))
        fprintf(stderr, "qnan == nan:  PASS\n");
    else
        fprintf(stderr, "qnan != nan:  FAIL\n");
    if (ieee_isQnan(qnan))
        fprintf(stderr, "qnan == qnan:  PASS\n");
    else
        fprintf(stderr, "qnan != qnan:  FAIL\n");
    if (!ieee_isSnan(qnan))
        fprintf(stderr, "qnan != snan:  PASS\n");
    else
        fprintf(stderr, "qnan == snan:  FAIL\n");

    return 0;
}
